unit ChxTaxAClasser;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RXCtrls, ExtCtrls, Grids,StructureDonnees,Donnees;

type
  TFormChxTaxonsAClasser = class(TForm)
    Panel1: TPanel;
    CheckListeTaxons: TRxCheckListBox;
    Panel2: TPanel;
    Label3: TLabel;
    Panel3: TPanel;
    Splitter1: TSplitter;
    Panel4: TPanel;
    Panel5: TPanel;
    Label1: TLabel;
    TableauTax: TStringGrid;
    ListeEtats: TListBox;
    AjLigne: TButton;
    Panel6: TPanel;
    CancelBtn: TButton;
    OKBtn: TButton;
    SuprLigne: TButton;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    procedure AjLigneClick(Sender: TObject);
    procedure SuprLigneClick(Sender: TObject);
    procedure TableauTaxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TableauTaxGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure ListeEtatsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Dclarations prives }
    ColonneClic:integer;
    LigneClic:integer;
    B:TBitmap;

  public
    { Dclarations publiques }
    SsCol:TSousCollection;
    PreRempli:Boolean;
    procedure initialise;
    procedure ConstruitTabRef;
  end;

var
  FormChxTaxonsAClasser: TFormChxTaxonsAClasser;

implementation
  uses typedef;
{$R *.dfm}

procedure TFormChxTaxonsAClasser.initialise;
var
  i,j,col:integer;
  UnTaxon:TTaxon;
  LeCarD:TCaractD;
  ListeTax:TStringList;
begin
  CheckListeTaxons.Clear;
  //recherche des taxons non cochs
  For i:=0 to SsCol.Taxons.NbTaxons-1 do
    begin
      UnTaxon:=TTaxon(SsCol.Taxons[i]);
      if (UnTaxon<>Nil) and (Pos('U',UnTaxon.TypeTaxon)=0) then
        begin
          If Not UnTaxon.Selected then
            begin
              CheckListeTaxons.Items.Add(UnTaxon.Nom);
            end;
        end;
    end;
  // remplissage des caractres du tableau
    TableauTax.ColCount:=1;
    TableauTax.RowCount:=2;
    col:=0;
    For i:= 0 to SsCol.Caracteres.CarDs.NbCarD-1 do
    begin
      LeCarD:=SsCol.CarD[i];
      if LeCarD<>Nil then
        begin
          if LeCarD.Selected then
            begin
              inc(col);
              TableauTax.ColCount:=Col+1;
              TableauTax.Cells[col,0]:=LeCarD.Nom;
              TableauTax.Cells[col,1]:='';
            end;
       end;
    end;                                    // le programme d'appel les slectionne en fonction de FormChoisir (tableau)
  TableauTax.Cells[0,0]:='Taxons';
  //recherche de taxons supplmentaires entrs dans classer
  if TableauTaxonsExe<>Nil then
    begin
      if TableauTaxonsExe[0]=Lasouscollection.Nom then
        begin
          ListeTax:=TStringList.Create;
          StringGrid2.RowCount:=TableauTaxonsExe.Count-1;
          StringGrid2.ColCount:=1;
          for i:=1 to TableauTaxonsExe.Count-1 do
            begin
              ListeTax.Clear;
              ListeTax.CommaText:=TableauTaxonsExe[i];
              if StringGrid2.ColCount<ListeTax.Count then
                StringGrid2.ColCount:=ListeTax.Count;
              for j:=0 to StringGrid2.ColCount-1 do
                StringGrid2.Cells[j,i-1]:=ListeTax[j];
            end;
          ListeTax.Free;
        end;
      TableauTax.RowCount:=StringGrid2.RowCount;
      For i:=1 to StringGrid2.RowCount-1 do
        begin
          TableauTax.Cells[0,i]:=StringGrid2.Cells[0,i];
          For j:=1 to StringGrid2.ColCount-1 do
            begin
              col:=TableauTax.Rows[0].IndexOf(StringGrid2.Cells[j,0]);
              if col>0 then
                TableauTax.Cells[col,i]:=StringGrid2.Cells[j,i];
            end;
        end;
    end;
end;
procedure TFormChxTaxonsAClasser.AjLigneClick(Sender: TObject);
Var
  n:integer;
begin
  n:=TableauTax.RowCount;
  TableauTax.RowCount:=n+1;
end;

procedure TFormChxTaxonsAClasser.SuprLigneClick(Sender: TObject);
Var
  n,i,j,l:integer;
begin
  n:=TableauTax.RowCount;
  if n=2 then
    begin
      for i:=0 to TableauTax.ColCount-1 do
        TableauTax.Cells[i,1]:='';
    end
  else
    begin
      l:=TableauTax.Row;
      if (l>0) and (l<n) then
        begin
          for i:=l to n-2 do
            for j:=0 to TableauTax.ColCount-1 do
              TableauTax.Cells[j,i]:=TableauTax.Cells[j,i+1];
          for j:=0 to TableauTax.ColCount-1 do
            TableauTax.Cells[j,n-1]:='';
          TableauTax.RowCount:=n-1;
        end;
    end;
end;

procedure TFormChxTaxonsAClasser.TableauTaxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
  col,lig,NumCaractD:integer;
  R:TRect;
begin
  TableauTax.MouseToCell(X, Y, Col, Lig);
  if (Col=0) or (lig=0) or(Col>=TableauTax.ColCount) or (Lig>=TableauTax.RowCount) then exit;
  ListeEtats.Clear;
  NumCaractD:=SsCol.Caracteres.GetNumCarD(TableauTax.Cells[Col,0]);
  ListeEtats.Items:=SsCol.Caracteres.GetEtats(NumCaractD);
  ListeEtats.Left:=X;
  ListeEtats.Top:=Y;
  ColonneClic:=Col;
  LigneClic:=Lig;
  ListeEtats.Height:=ListeEtats.ItemHeight*(ListeEtats.Items.Count+1); // pour afficher tous les tats
  R:=ListeEtats.BoundsRect;
  B:=TBitmap.Create;
  B.Canvas.copyrect(Rect(0,0,ListeEtats.Width,ListeEtats.Height),ListeEtats.Canvas,ListeEtats.BoundsRect);
  ListeEtats.Visible:=True;
end;

procedure TFormChxTaxonsAClasser.TableauTaxGetEditText(Sender: TObject;
  ACol, ARow: Integer; var Value: String);
begin
  if (ARow=0)or (ACol>0) then
    begin
      Value:=TableauTax.Cells[ACol,ARow];
    end;
end;

procedure TFormChxTaxonsAClasser.ListeEtatsClick(Sender: TObject);
begin
  if (ColonneClic>0) and (LigneClic>0) then
    begin
      with TableauTax do
        begin
          Cells[ColonneClic,LigneClic]:=ListeEtats.Items[ListeEtats.ItemIndex];
          ListeEtats.Visible:=False;
          Canvas.CopyRect(ListeEtats.BoundsRect,B.Canvas,Rect(0,0,ListeEtats.Width,ListeEtats.Height));
          SetFocus;
        end;
    end;

end;

procedure TFormChxTaxonsAClasser.FormCreate(Sender: TObject);
begin
  ColonneClic:=0;
  LigneClic:=0;
  PreRempli:=False;
end;

procedure TFormChxTaxonsAClasser.OKBtnClick(Sender: TObject);
Var
  i,k,l,p:integer;
  UnTaxon,UnDTaxon:TTaxon;
  function Verifieligne:boolean;
  var
    j:integer;
    UnCarD:TCaractD;
  begin
    result:=True;
    for j:=0 to TableauTax.ColCount-1 do
      begin
        if TableauTax.Cells[j,i]='' then
          begin
            result:=false;
            break;
          end;
        if j>0 then
          begin
            UnCarD:=SsCol.LeCarD(TableauTax.Cells[j,0]);
            if (UnCarD=Nil) or (UnCarD.ListeEtats.IndexOf(TableauTax.Cells[j,i])<0) then
              begin
                result:=false;
                break;
              end
            else if (UnCarD.ListeEtats.IndexOf(TableauTax.Cells[j,i])<0) then
              begin
                result:=false;
                break;
              end;
          end;
      end;
  end;
begin
  //Ajouter les Taxons cochs comme Taxons d'exercice
  For i:=0 to CheckListeTaxons.Items.Count-1 do
    if CheckListeTaxons.Checked[i] then
      begin
        UnTaxon:=SsCol.LeTaxon(CheckListeTaxons.Items[i]);
        if UnTaxon<>Nil then
          begin
            UnTaxon.Selected:=True;
            if pos('X',UnTaxon.TypeTaxon)=0 then
              UnTaxon.TypeTaxon:=UnTaxon.TypeTaxon+'X';
          end;
      end;
  //limiter le TableauRef aux caractres
  StringGrid1.RowCount:=1;
  StringGrid1.ColCount:=TableauTax.ColCount;
  StringGrid1.Cells[0,0]:='';
  For k:=0 to TableauTax.Colcount-1 do
    StringGrid1.Cells[k,0]:=TableauTax.Cells[k,0];
  l:=1;
  For i:=0 to SsCol.Taxons.NbTaxons-1 do
    begin
      UnTaxon:=TTaxon(SsCol.Taxons[i]);
      if UnTaxon<>nil then
        begin
          UnDTaxon:=LaSouscollection.LeTaxon(UnTaxon.Nom);
          if UnDTaxon<>Nil then
            begin
              StringGrid1.RowCount:=l+1;
              StringGrid1.Cells[0,l]:=UnTaxon.Nom;
              For k:=1 to TableauTax.Colcount-1 do
                begin
                  StringGrid1.Cells[k,l]:=LaSousCollection.EtatDe(UnTaxon.Nom,TableauTax.Cells[k,0],p);
                end;
              inc(l);
            end;
        end;
    end;
  //Ajouter les taxons du tableau si ligne remplie comme taxons d'exercice
  For i:=1 to TableauTax.RowCount-1 do
    begin
      if Verifieligne then
        begin
          UnTaxon:=TTaxon.create;
          UnTaxon.Nom:=TableauTax.Cells[0,i];
          UnTaxon.TypeTaxon:='X';
          UnTaxon.Image:='';
          UnTaxon.Selected:=True;
          UnTaxon.AgeApp:=0;
          UnTaxon.AgeDisp:=0;
          For k:=0 to SsCol.Caracteres.Noms.Count-1 do
            UnTaxon.ImageCars.Add('');

          SsCol.Taxons.AddTaxon(UnTaxon);
          StringGrid1.RowCount:=l+1;
          StringGrid1.Cells[0,l]:=UnTaxon.Nom;

          //Rajouter les nouveaux taxons TableauRef
          For k:=1 to TableauTax.Colcount-1 do
            StringGrid1.Cells[k,l]:=TableauTax.Cells[k,i];
          inc(l);
        end;
    end;
  l:=0;
  //SsCol.TabRef.LitDeStringGrid(0,0,StringGrid1);

  ModalResult:=mrOK;
end;
procedure TFormChxTaxonsAClasser.ConstruitTabRef;
Var
  i,l,k,p:integer;
  UnTaxon,UnDTaxon:TTaxon;
begin
  //limiter le TableauRef aux caractres
  StringGrid1.RowCount:=1;
  StringGrid1.ColCount:=TableauTax.ColCount;
  StringGrid1.Cells[0,0]:='';
  For k:=0 to TableauTax.Colcount-1 do
    StringGrid1.Cells[k,0]:=TableauTax.Cells[k,0];
  l:=1;
  For i:=0 to SsCol.Taxons.NbTaxons-1 do
    begin
      UnTaxon:=TTaxon(SsCol.Taxons[i]);
      if UnTaxon<>nil then
        begin
          UnDTaxon:=LaSouscollection.LeTaxon(UnTaxon.Nom);
          if UnDTaxon<>Nil then
            begin
              StringGrid1.RowCount:=l+1;
              StringGrid1.Cells[0,l]:=UnTaxon.Nom;
              For k:=1 to TableauTax.Colcount-1 do
                begin
                  StringGrid1.Cells[k,l]:=LaSousCollection.EtatDe(UnTaxon.Nom,TableauTax.Cells[k,0],p);
                end;
              inc(l);
            end;
        end;
    end;
end;
end.
