unit PhyloRech;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, CheckLst;

type
  TFormRecherche = class(TForm)
    MainMenu1: TMainMenu;
    Fermer1: TMenuItem;
    Ajouter: TMenuItem;
    Supprimer: TMenuItem;
    PanelCarac: TPanel;
    PanSelectionner: TPanel;
    Selectionner: TButton;
    Panel4: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    ComboCar4: TComboBox;
    ComboEtat4: TComboBox;
    Panel8: TPanel;
    est4: TRadioButton;
    RadioButton8: TRadioButton;
    Panel9: TPanel;
    Et3: TRadioButton;
    RadioButton10: TRadioButton;
    Panel3: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    ComboCar3: TComboBox;
    ComboEtat3: TComboBox;
    Panel11: TPanel;
    Est3: TRadioButton;
    RadioButton12: TRadioButton;
    Panel12: TPanel;
    Et2: TRadioButton;
    RadioButton14: TRadioButton;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    ComboCar2: TComboBox;
    ComboEtat2: TComboBox;
    Panel5: TPanel;
    Est2: TRadioButton;
    RadioButton4: TRadioButton;
    Panel6: TPanel;
    Et1: TRadioButton;
    RadioButton6: TRadioButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    ComboCar1: TComboBox;
    ComboEtat1: TComboBox;
    Panel1b: TPanel;
    est1: TRadioButton;
    RadioButton2: TRadioButton;
    Panelhaut: TPanel;
    Rechercher: TButton;
    Panelgroupe: TPanel;
    MemoCarGroupes: TMemo;
    Panel7: TPanel;
    ComboGroupes: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    PanelCoulG: TPanel;
    Label11: TLabel;
    Couleur: TPanel;
    ColorDialog: TColorDialog;
    Annuler: TButton;
    ListTaxons: TCheckListBox;
    AjouterSel: TButton;
    Voir1: TButton;
    Voir2: TButton;
    Voir3: TButton;
    Voir4: TButton;
    ToutCocher: TMenuItem;
    Decocher: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure AjouterClick(Sender: TObject);
    procedure SupprimerClick(Sender: TObject);
    procedure RechercherClick(Sender: TObject);
    procedure SelectionnerClick(Sender: TObject);
    procedure ComboGroupesChange(Sender: TObject);
    procedure CouleurClick(Sender: TObject);
    procedure AnnulerClick(Sender: TObject);
    procedure ComboCarChange(Sender: TObject);
    procedure AjouterSelClick(Sender: TObject);
    procedure VoirClick(Sender: TObject);
    procedure ToutCocherClick(Sender: TObject);
    procedure DecocherClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    NbCriteres:integer;
    CombosEtat:Array[0..3] of TCombobox;
    CombosCar:Array[0..3] of TCombobox;
    Crits:Array[0..3] of TRadioButton;
    Conjonct:Array[1..3] of TRadioButton;
    PanCrit:Array[0..3] of TPanel;
    OnRetourSelection:TNotifyEvent;
    OnRetourAjoutSelection:TNotifyEvent;
    initialisation:boolean;
    EnInitialisation:boolean;
    function initialise:boolean;
    function TesteTaxon(NomTax,NomCar,Etat:string;identique:boolean):boolean;
  end;

var
  FormRecherche: TFormRecherche;

implementation
uses StructureDonnees,Donnees,AfDocs;
{$R *.dfm}

procedure TFormRecherche.FormCreate(Sender: TObject);
begin
  NbCriteres:=1;
  CombosEtat[0]:=ComboEtat1;
  CombosEtat[1]:=ComboEtat2;
  CombosEtat[2]:=ComboEtat3;
  CombosEtat[3]:=ComboEtat4;
  CombosCar[0]:=ComboCar1;
  CombosCar[1]:=ComboCar2;
  CombosCar[2]:=ComboCar3;
  CombosCar[3]:=ComboCar4;
  Crits[0]:=Est1;
  Crits[1]:=Est2;
  Crits[2]:=Est3;
  Crits[3]:=Est4;
  Conjonct[1]:=Et1;
  Conjonct[2]:=Et2;
  Conjonct[3]:=Et3;
  PanCrit[0]:=Panel1;
  PanCrit[1]:=Panel2;
  PanCrit[2]:=Panel3;
  PanCrit[3]:=Panel4;
end;
function TFormRecherche.initialise:boolean;
Var
  i,j:integer;
  UnCarD:TCaractD;
begin
  if initialisation then
    begin
      Result:=True;
      exit;
    end;
  Eninitialisation:=true;
  initialisation:=true;
  Result:=True;
  width:=800;
  ListTaxons.Clear;
  MemoCarGroupes.Clear;
  For j:=0 to 3 do
    begin
      CombosCar[j].Clear;
      CombosEtat[j].Clear;
      For i:=0 to LaSousCollection.Caracteres.CarDs.NbCarD-1 do
        begin
          UnCarD:=LaSousCollection.Caracteres.CarDs.Items[i];
          if UnCarD<>Nil then CombosCar[j].Items.Add(UnCarD.Nom);
        end;
      if CombosCar[j].Items.Count>0 then
        begin
          CombosCar[j].ItemIndex:=-1;
          CombosEtat[j].Clear;
        end
      else
        begin
          Result:=False;
          initialisation:=false;
          exit;
        end;
    end;
  // Recherche des groupes prdfinis
  ComboGroupes.Clear;
  ComboGroupes.Items.AddStrings(LaSouscollection.EnsGroupes);
  if ComboGroupes.Items.Count>0 then
    begin
      Panelgroupe.Visible:=True;
      ComboGroupes.ItemIndex:=-1;
      MemoCarGroupes.Clear;
    end
  else
    begin
      Panelgroupe.Visible:=False;
      MemoCarGroupes.Clear;
      width:=570;
    end;
  ListTaxons.Align:=alClient;
  Eninitialisation:=false;
end;
function TFormRecherche.TesteTaxon(NomTax,NomCar,Etat:string;identique:boolean):boolean;
begin
  Result:=((LaSousCollection.EtatRef[NomTax,NomCar]=Etat)=identique);
end;

procedure TFormRecherche.AjouterClick(Sender: TObject);
begin
  if NbCriteres<4 then
    begin
      PanCrit[NbCriteres].Visible:=True;
      inc(NbCriteres);
      if NbCriteres=4 then Ajouter.Enabled:=False;
      Supprimer.Enabled:=True;
    end;
end;

procedure TFormRecherche.SupprimerClick(Sender: TObject);
begin
  if NbCriteres>1 then
    begin
      dec(NbCriteres);
      PanCrit[NbCriteres].Visible:=False;
      if NbCriteres=1 then Supprimer.Enabled:=False;
      Ajouter.Enabled:=True;
    end;
end;

procedure TFormRecherche.RechercherClick(Sender: TObject);
Var
  Sel:boolean;
  i,j,n:integer;
  Tax:TTaxon;
  identique:boolean;
  Possible:boolean;
begin
  Possible:=True;
  For i:=0 to NbCriteres-1 do
    begin
      Possible:=(Possible and (CombosCar[i].ItemIndex>=0));
      Possible:=(Possible and (CombosEtat[i].ItemIndex>=0));
    end;
  if Not Possible then exit;
  ListTaxons.Clear;
  for i:=0 to LaSousCollection.Taxons.NbTaxons-1 do
    begin
      Tax:=TTaxon(LaSousCollection.Taxons[i]);
      if (Tax<>Nil) then
        begin
          identique:=Crits[0].Checked;
          Sel:=TesteTaxon(Tax.Nom,CombosCar[0].Text,CombosEtat[0].Text,identique);
          for j:=1 to NbCriteres-1 do
            begin
              identique:=Crits[j].Checked;
              if Conjonct[j].Checked then
                Sel:=Sel and TesteTaxon(Tax.Nom,CombosCar[j].Text,CombosEtat[j].Text,identique)
              else
                Sel:=Sel or TesteTaxon(Tax.Nom,CombosCar[j].Text,CombosEtat[j].Text,identique);
            end;
          if Sel then
            begin
              n:=ListTaxons.Items.Add(Tax.Nom);
              ListTaxons.Checked[n]:=True;
            end;
        end;
    end;
end;

procedure TFormRecherche.SelectionnerClick(Sender: TObject);
Var
  Tax:TTaxon;
  i:integer;
begin
  if ListTaxons.Count>0 then
    begin
      LaSousCollection.Taxons.RAZSelected;
      For i:=0 to ListTaxons.Count-1 do
        if ListTaxons.Checked[i] then
          begin
            Tax:=LaSousCollection.LeTaxon(ListTaxons.Items[i]);
            if Tax<>Nil then Tax.Selected:=True;
          end;
      if Assigned(OnRetourSelection) then OnRetourSelection(Self);
    end;
end;

procedure TFormRecherche.ComboGroupesChange(Sender: TObject);
Var
  Lignes:TStrings;
begin
  if Eninitialisation then exit;
  if trim(ComboGroupes.Text)<>'' then
    begin
      Lignes:=TStringList.Create;
      LaSousCollection.ListeCaractGroupe(true,ComboGroupes.Text,Lignes);
      MemoCarGroupes.Clear;
      MemoCarGroupes.Lines.AddStrings(Lignes);
      Lignes.Free;
    end;
end;

procedure TFormRecherche.CouleurClick(Sender: TObject);
begin
  ColorDialog.Color:=Couleur.Color;
  if ColorDialog.Execute then
    Couleur.Color:=ColorDialog.Color;
end;

procedure TFormRecherche.AnnulerClick(Sender: TObject);
begin
  ListTaxons.Clear;
  if Assigned(OnRetourSelection) then OnRetourSelection(Self);
end;

procedure TFormRecherche.ComboCarChange(Sender: TObject);
Var
  i:integer;
  //trouve:boolean;
  UnCarD:TCaractD;
begin
  For i:=0 to 3 do
    if Sender=CombosCar[i] then
      begin
        CombosEtat[i].Clear;
        UnCarD:=LaSousCollection.LeCarD(CombosCar[i].Text);
        if UnCarD<>Nil then
          begin
            CombosEtat[i].Items.AddStrings(UnCarD.ListeEtats);
            if CombosEtat[i].Items.Count>1 then CombosEtat[i].ItemIndex:=1;
          end;
        break;
      end;
end;

procedure TFormRecherche.AjouterSelClick(Sender: TObject);
Var
  Tax:TTaxon;
  i:integer;
begin
  if ListTaxons.Count>0 then
    begin
      LaSousCollection.Taxons.RAZSelected;
      For i:=0 to ListTaxons.Count-1 do
        if ListTaxons.Checked[i] then
          begin
            Tax:=LaSousCollection.LeTaxon(ListTaxons.Items[i]);
            if Tax<>Nil then Tax.Selected:=True;
          end;
      if Assigned(OnRetourAjoutSelection) then OnRetourAjoutSelection(Self);
    end;
end;

procedure TFormRecherche.VoirClick(Sender: TObject);
Var
  NomCaractere:string;
  i:integer;
begin
  i:=(Sender as TButton).Tag;
  NomCaractere:=CombosCar[i].Text;
  if NomCaractere<>'' then AfficheDocs.IllustreEtats(NomCaractere);
end;

procedure TFormRecherche.ToutCocherClick(Sender: TObject);
Var
  i:integer;
begin
  For i:=0 to ListTaxons.Count-1 do
    ListTaxons.Checked[i]:=True;
end;

procedure TFormRecherche.DecocherClick(Sender: TObject);
Var
  i:integer;
begin
  For i:=0 to ListTaxons.Count-1 do
    ListTaxons.Checked[i]:=False;
end;

end.
